/**
 * @file DllMain.cpp
 * @brief DLL֐̎
 * @author Shinji Watanabe
 * @date 2009/01/10
 */

#include "Cursor.h"
#include "CharsetDetector.h"
#include "ConvFactory.h"

#ifndef UNDER_CE
#	pragma comment (lib,"imm32.lib")		//!< IME֘ÃCu
#endif

#define FOOTY_VER			2017			//!< Footỹo[W~1000
#define FOOTY_BETA			0				//!< Footỹo[Wԍ

/*O[oϐ̒`*/
static CRITICAL_SECTION g_CriticalSection;	//!< NeBJZNV
static std::list<CFooty*> *g_plsFooty = NULL;
static HINSTANCE g_hInstance = NULL;

//-----------------------------------------------------------------------------
/**
 * @brief w肳ꂽIDFootyRg[|C^擾܂B
 */
CFooty *GetFooty(int nID)
{
	EnterCriticalSection(&g_CriticalSection);
	{
		if (!g_plsFooty)
		{
			LeaveCriticalSection(&g_CriticalSection);
			return NULL;
		}
		// 񂵂Ă
		for (FootyPt pRetFooty = g_plsFooty->begin();
			pRetFooty != g_plsFooty->end();
			pRetFooty++)
		{
			if ((*pRetFooty)->GetID() == nID)
			{
				LeaveCriticalSection(&g_CriticalSection);
				return *pRetFooty;
			}
		}
	}
	LeaveCriticalSection(&g_CriticalSection);
	return NULL;
}

//-----------------------------------------------------------------------------
/**
 * @brief o͂܂
 */
#ifdef PRINT_ENABLED
void FormatPrint( const wchar_t* filename, int nLine, const wchar_t* fmt, ... )
{
	const int MaxLogBuffer = 1024;
	wchar_t szText[ MaxLogBuffer + 1 ];
	
	swprintf( szText, MaxLogBuffer, L"%s(%d):", filename, nLine );
	OutputDebugStringW( szText );

	va_list vaList;
	va_start( vaList, fmt );
	vswprintf_s( szText, MaxLogBuffer, fmt, vaList );
	va_end( vaList );

	OutputDebugStringW( szText );
}
#endif


//-----------------------------------------------------------------------------
/**
 * @brief JnɌĂяo܂BFooty2Cu܂
 */
FOOTYEXPORT(void) Footy2Start(HINSTANCE hInstance)
{
	InitializeCriticalSection(&g_CriticalSection);
	EnterCriticalSection(&g_CriticalSection);
	{
		g_hInstance = hInstance;
		g_plsFooty = new std::list<CFooty*>;
	}
	LeaveCriticalSection(&g_CriticalSection);
	CCursor::LoadCursors(hInstance);
	CFootyView::LoadLineIcons(hInstance);
}

//-----------------------------------------------------------------------------
/**
 * @brief IɌĂяo܂
 */
FOOTYEXPORT(void) Footy2End()
{
	FootyPt iterFooty;
	// Footỹ|C^폜Ă
	EnterCriticalSection(&g_CriticalSection);
	if (g_plsFooty)
	{
		for (iterFooty = g_plsFooty->begin();iterFooty != g_plsFooty->end();iterFooty++)
		{
			if (*iterFooty)
			{
				delete (*iterFooty);
				*iterFooty = NULL;
			}
		}
		delete g_plsFooty;
		g_plsFooty = NULL;
	}
	LeaveCriticalSection(&g_CriticalSection);
	// J[\j
	CCursor::DestroyCursors();
	CFootyView::ReleaseLineIcons();
}

#if !defined FOOTYSTATIC
//-----------------------------------------------------------------------------
/**
 * @brief DLL̃C֐łB
 */
BOOL APIENTRY DllMain(HANDLE hInst, DWORD  fdwReason, LPVOID lpReserved)
{
	switch(fdwReason)
	{
	case DLL_PROCESS_ATTACH:		// vZXɃA^b`ꂽB
		Footy2Start((HINSTANCE)hInst);
		break;
	case DLL_PROCESS_DETACH:		// vZXɃf^b`ꂽB
		Footy2End();
#if defined _DEBUG && !defined UNDER_CE
	_CrtDumpMemoryLeaks();			// [No
#endif	/*_DEBUG*/
		break;
	}
	return true;
}
#endif	/*!defined FOOTYSTATIC*/

//-----------------------------------------------------------------------------
/**
 * @brief o[W擾܂
 */
FOOTYEXPORT(int) GetFooty2Ver()
{
	return FOOTY_VER;
}

//-----------------------------------------------------------------------------
/**
 * @brief o[W擾܂
 */
FOOTYEXPORT(int) GetFooty2BetaVer()
{
	return FOOTY_BETA;
}

//-----------------------------------------------------------------------------
/**
 * @brief Footy\z܂
 */
FOOTYEXPORT(int) Footy2Create(HWND hWnd,int x,int y,int dx,int dy,int nMode)
{
	// G[`FbN
	if (!hWnd || dx < 0 || dy < 0)
	{
		return FOOTY2ERR_ARGUMENT;
	}

	// Footymۂ
	int nID;
	// Xg֑
	EnterCriticalSection(&g_CriticalSection);
		FootyPt iterFooty = g_plsFooty->begin();
		for (nID = 0;iterFooty != g_plsFooty->end();iterFooty++,nID++)
		{
			if ((*iterFooty)->GetID() != nID)		//r
			{
				break;
			}
		}
		// FootyIuWFNg\z܂
		CFooty *pFooty = new CFooty( nID, g_hInstance, nMode );
		if (!pFooty)
		{
			LeaveCriticalSection(&g_CriticalSection);
			return FOOTY2ERR_MEMORY;
		}
		g_plsFooty->insert(iterFooty,pFooty);
	LeaveCriticalSection(&g_CriticalSection);
	
	// \z
	pFooty->Create( hWnd, x, y, dx, dy );
	
	// IDԂ
	return nID;
}

//-----------------------------------------------------------------------------
/**
 * @brief eEBhEύX܂
 */
FOOTYEXPORT(int) Footy2ChangeParent(int nID, HWND hWnd, int x,int y, int dx,int dy)
{
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	pFooty->Create( hWnd, x, y, dx, dy );
	return FOOTY2ERR_NONE;
}

/*----------------------------------------------------------------
Footy2ChangeView
Footỹr[[h̕ύXłB
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2ChangeView(int nID,int nView){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	pFooty->ChangeView(nView);
	return FOOTY2ERR_NONE;
}

/*----------------------------------------------------------------
Footy2SetFocus
Footỹr[[h̕ύXłB
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2SetFocus(int nID,int nViewID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	if (nViewID < 0 || 4 < nViewID)return FOOTY2ERR_ARGUMENT;
	pFooty->m_cView[nViewID].SetFocus();
	return FOOTY2ERR_NONE;
}

/*----------------------------------------------------------------
Footy2GetWnd
FootỹEBhEnh擾܂
----------------------------------------------------------------*/
FOOTYEXPORT(HWND) Footy2GetWnd(int nID,int nViewID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return NULL;
	if (nViewID < 0 || 4 < nViewID)return NULL;
	return pFooty->m_cView[nViewID].GetWnd();
}

/*----------------------------------------------------------------
Footy2GetWndVSplit
FootyVSplit̃EBhEnh擾܂
----------------------------------------------------------------*/
FOOTYEXPORT(HWND) Footy2GetWndVSplit(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return NULL;
	return pFooty->m_cVSplitter.GetWnd();
}

/*----------------------------------------------------------------
Footy2GetWndHSplit
FootyHSplit̃EBhEnh擾܂
----------------------------------------------------------------*/
FOOTYEXPORT(HWND) Footy2GetWndHSplit(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return NULL;
	return pFooty->m_cHSplitter.GetWnd();
}

/*----------------------------------------------------------------
Footy2GetWndHSplit
FootyHSplit̃EBhEnh擾܂
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetActiveView(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	/*擾*/
	int nRet = FOOTY2ERR_NOACTIVE;
	for (int i=0;i<4;i++){
		if (pFooty->m_cView[i].IsFocused())
			nRet = i;
	}
	return nRet;
}

/*----------------------------------------------------------------
Footy2Delete
Footy폜܂B
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2Delete(int id){
	CFooty *pFooty = GetFooty(id);
	if (!pFooty)return FOOTY2ERR_NOID;
	/*Xg폜*/
	g_plsFooty->remove(pFooty);
	/*|C^폜*/
	if (pFooty){
		delete pFooty;
		pFooty = NULL;
	}
	return FOOTY2ERR_NONE;
}


/*----------------------------------------------------------------
Footy2Move
Footy2EBhEړ邽߂̊֐łB
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2Move(int nID,int x,int y,int dx,int dy){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	return pFooty->Move(x,y,dx,dy) ? FOOTY2ERR_NONE : FOOTY2ERR_ARGUMENT;
}

/*----------------------------------------------------------------
Footy2Refresh
Footy2EBhEĕ`悷鏈
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2Refresh(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	pFooty->m_cView[0].Refresh();
	return FOOTY2ERR_NONE;
}

/*----------------------------------------------------------------
Footy2CreateNew
VK쐬
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2CreateNew(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	/*VK쐬*/
	pFooty->m_cDoc.CreateNew(nID);
	pFooty->SetCharSet(CSM_DEFAULT);
	return FOOTY2ERR_NONE;
}

/*----------------------------------------------------------------
Footy2GetCharSet
R[hZbg擾鏈
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetCharSet(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return CSM_ERROR;
	return pFooty->GetCharSet();
}

/*----------------------------------------------------------------
Footy2GetLineCode
VK쐬
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetLineCode(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return LM_ERROR;
	return pFooty->m_cDoc.GetLineMode();
}

/*----------------------------------------------------------------
Footy2GetLines
Ss擾܂B
----------------------------------------------------------------*/
FOOTYEXPORT(int)Footy2GetLines(int nID){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	/*s擾*/
	return (int)pFooty->m_cDoc.GetLineNum();
}


#ifndef UNDER_CE
/**
 * Footy2GetLineA
 * @brief ws̃eLXg擾܂B
 * @param nID FootyIDԍ
 * @param pString o͐
 * @param nLine o͂s
 * @param nSize obt@TCY
 */
FOOTYEXPORT(int) Footy2GetLineA(int nID,char *pString,size_t nLine,int nSize){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	/*Ys擾*/
	if (nLine < 0 || pFooty->m_cDoc.GetLineNum() <= nLine)return FOOTY2ERR_ARGUMENT;
	LinePt pLine = pFooty->m_cDoc.GetLine(nLine);
	/*f[^Ԃ*/
	CConvFactory cConv;
	cConv.GetConv()->ToMulti(pLine->GetLineData(), (UINT)pLine->GetLineLength());
	FOOTY2STRCPY(pString,cConv.GetConv()->GetConvData(),nSize);
	return FOOTY2ERR_NONE;
}
#endif	/*UNDER_CE*/

/*----------------------------------------------------------------
Footy2GetLineW
ws̃eLXg擾܂B
----------------------------------------------------------------*/
FOOTYEXPORT(const wchar_t*) Footy2GetLineW(int nID,size_t nLine){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return NULL;
	/*Ys擾*/
	if (nLine < 0 || pFooty->m_cDoc.GetLineNum() <= nLine)return NULL;
	LinePt pLine = pFooty->m_cDoc.GetLine(nLine);
	/*f[^Ԃ*/
	return pLine->GetLineData();
}


#ifndef UNDER_CE
/*----------------------------------------------------------------
Footy2SetLineA
ws̃eLXgݒ肵܂B
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2SetLineA(int nID,size_t nLine,const char *pString,bool bRedraw){
	CConvFactory cConv;
	cConv.GetConv()->ToUnicode(pString,(UINT)strlen(pString));
	return Footy2SetLineW(nID,nLine,(wchar_t*)cConv.GetConv()->GetConvData(),bRedraw);
}
#endif

/*----------------------------------------------------------------
Footy2SetLineW
ws̃eLXgݒ肵܂B
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2SetLineW(int nID,size_t nLine,const wchar_t *pString,bool bRedraw){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return NULL;
	if (!pString)return FOOTY2ERR_ARGUMENT;
	/*I*/
	CFootyDoc *pDoc = &pFooty->m_cDoc;
	if (!pDoc->GetCaretPosition()->SetPosition(pDoc->GetLineList(),nLine,0))
		return FOOTY2ERR_ARGUMENT;
	LinePt pLine = pDoc->GetCaretPosition()->GetLinePointer();
	pDoc->SetSelectStart();
	pDoc->GetCaretPosition()->SetPosition(pLine,pLine->GetLineLength());
	pDoc->SetSelectEndNormal();
	/*ݒ肷*/
	pDoc->InsertString(pString);
	/*LbgʒuĐݒ*/
	for (int i=0;i<4;i++){
		pFooty->m_cView[i].AdjustVisibleLine();
		pFooty->m_cView[i].AdjustVisiblePos();
	}
	/*ĕ`揈*/
	if (bRedraw)pFooty->m_cView[0].Refresh();
	return FOOTY2ERR_NONE;
}

#ifndef UNDER_CE
/*----------------------------------------------------------------
Footy2GetLineSizeA
ws̒擾܂B
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetLineLengthA(int nID,size_t nLine){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return -1;
	/*Ys擾*/
	if (pFooty->m_cDoc.GetLineNum() <= nLine)return -1;
	LinePt pLine = pFooty->m_cDoc.GetLine(nLine);
	/*f[^Ԃ*/
	CConvFactory cConv;
	cConv.GetConv()->ToMulti(pLine->GetLineData(), (UINT)pLine->GetLineLength());
	return (int)cConv.GetConv()->GetConvTextSize() - sizeof(char);
}
#endif

/*----------------------------------------------------------------
Footy2GetLineSizeW
ws̒擾܂B
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetLineLengthW(int nID,size_t nLine){
	/*Footy擾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	/*Ys擾*/
	if (pFooty->m_cDoc.GetLineNum() <= nLine)return FOOTY2ERR_ARGUMENT;
	LinePt pLine = pFooty->m_cDoc.GetLine(nLine);
	/*f[^Ԃ*/
	return (int)pLine->GetLineLength();
}

/*----------------------------------------------------------------
Footy2SetLapel
܂Ԃݒ
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2SetLapel(int nID,int nColumns,int nMode,bool bRedraw){
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	return pFooty->SetLapel(nColumns,nMode,bRedraw) ? FOOTY2ERR_NONE : FOOTY2ERR_ARGUMENT;
}

/*----------------------------------------------------------------
Footy2GetVisibleColumns
\\Ȍ擾鏈
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetVisibleColumns(int nID,int nViewID){
	/*錾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	if (nViewID < 0 || 4 <= nViewID)return FOOTY2ERR_ARGUMENT;
	return (int)pFooty->m_cView[nViewID].GetVisibleColumns();
}

/*----------------------------------------------------------------
Footy2GetVisibleLines
\\ȍs擾鏈
----------------------------------------------------------------*/
FOOTYEXPORT(int) Footy2GetVisibleLines(int nID,int nViewID){
	/*錾*/
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	if (nViewID < 0 || 4 <= nViewID)return FOOTY2ERR_ARGUMENT;
	return (int)pFooty->m_cView[nViewID].GetVisibleLines();
}

/*[EOF]*/
